cundina/cundina/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include("home.urls", namespace="home")),
    path('', include("onv.urls", namespace="onv")),
    path('', include("shi.urls", namespace="shi")),
]

cundina/onv/urls.py
from django.urls import path

from onv import views

app_name = "onv"

urlpatterns = [
    path('list_contribuyente/', views.ListContribuyente.as_view(), name="list_contribuyente"),
    path('new_contribuyente/', views.NewContribuyente.as_view(), name="new_contribuyente"),
    path('update_contribuyente/<int:pk>/', views.UpdateContribuyente.as_view(), name="update_contribuyente"),
    path('delete_contribuyente/<int:pk>/', views.DeleteContribuyente.as_view(), name="delete_contribuyente"),
    path('new_aporte/', views.NewAporte.as_view(), name="new_aporte"),
    path('list_aporte/', views.ListAporte.as_view(), name="list_aporte"),
    path('update_aporte/<int:pk>/', views.UpdateAporte.as_view(), name="update_aporte"),
    path('delete_aporte/<int:pk>/', views.DeleteAporte.as_view(), name="delete_aporte"),
    path('detail_contribuyente/<int:pk>/', views.DetailContribuyente.as_view(), name="detail_contribuyente"),
    path('detail_aporte/<int:pk>/', views.DetailAporte.as_view(), name="detail_aporte"),
    path('ws/list_contribuyente/', views.wsList, name="ws_list_contribuyente"),
    path('list_gerente/', views.ListGerente.as_view(), name="list_gerente"),
    path('new_gerente/', views.NewGerente.as_view(), name="new_gerente"),
    path('update_gerente/<int:pk>/', views.UpdateGerente.as_view(), name="update_gerente"),
    path('delete_gerente/<int:pk>/', views.DeleteGerente.as_view(), name="delete_gerente"),
    path('list_cundina/', views.ListCundina.as_view(), name="list_cundina"),
    path('new_cundina/', views.NewCundina.as_view(), name="new_cundina"),
    path('update_cundina/<int:pk>/', views.UpdateCundina.as_view(), name="update_cundina"),
    path('delete_cundina/<int:pk>/', views.DeleteCundina.as_view(), name="delete_cundina"),

    ]

cundina/shi/urls.py
from django.urls import path

from shi import views

app_name = "shi"

urlpatterns =[
    path('list_turnos/', views.ListTurnos.as_view(), name="list_turnos"),
    path('new_turnos/', views.NewTurnos.as_view(), name="new_turnos"),
    path('update_turnos/<int:pk>/', views.UpdateTurnos.as_view(), name="update_turnos"),
    path('delete_turnos/<int:pk>/', views.DeleteTurnos.as_view(), name="delete_turnos"),
    path('new_contribucion/', views.NewContribucion.as_view(), name="new_contribucion"),
    path('list_contribucion/', views.ListContribucion.as_view(), name="list_contribucion"),
    path('update_contribucion/<int:pk>/', views.UpdateContribucion.as_view(), name="update_contribucion"),
    path('delete_contribucion/<int:pk>/', views.DeleteContribucion.as_view(), name="delete_contribucion"),
]

cundina/shi/models.py
from django.db import models

from onv.models import BaseModel, Gerente, Contribuyente, Aporte, Cundina

# Create your models here.
class Turnos(BaseModel):
    cundina = models.ForeignKey(Cundina, on_delete=models.CASCADE)
    turnos = models.FloatField(default=0)
    gerente = models.ForeignKey(Gerente, on_delete=models.CASCADE)


    def save(self):
        super(Turnos, self).save()


    class Meta:
        verbose_name_plural = "Turnos"


class Contribucion(BaseModel):
    cundina = models.ForeignKey(Cundina, on_delete=models.CASCADE)
    contribuyente = models.ForeignKey(Contribuyente, on_delete=models.CASCADE)
    aporte = models.ForeignKey(Aporte, on_delete=models.CASCADE)


    def save(self):
        super(Contribucion, self).save()


    class Meta:
        verbose_name_plural = "Turnos"

cundina/shi/forms.py
from django import forms

from .models import Contribucion, Turnos

class ContribucionForm(forms.ModelForm):
    class Meta:
        model = Contribucion
        fields = [ ## "__all__"
            "cundina",
            "contribuyente",
            "aporte",
        ]
        exclude = ["user", "user_update", "timestamp", "update"]
        labels = {
            "cundina": "Cundina",
            "contribuyente": "Contribuyente",
            "aporte": "Aporte",
        }

    def __init__(self, *args, **kwargs):
            super().__init__(*args, **kwargs)
            for field in iter(self.fields):
                self.fields[field].widget.attrs.update({
                    "class": "form-control"
                })

class TurnosForm(forms.ModelForm):
    class Meta:
        model = Turnos
        fields = [ ## "__all__"
            "cundina",
            "turnos",
            "gerente",
        ]
        exclude = ["user", "user_update", "timestamp", "update"]
        labels = {
            "cundina": "Cundina",
            "turnos": "Turnos",
            "gerente": "Gerente",
        }

    def __init__(self, *args, **kwargs):
            super().__init__(*args, **kwargs)
            for field in iter(self.fields):
                self.fields[field].widget.attrs.update({
                    "class": "form-control"
                })

cundina/shi/views.py
from django.shortcuts import render
from django.views import generic
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse_lazy

from .models import Turnos,Contribucion
from .forms import TurnosForm, ContribucionForm
# Create your views here.

class ListTurnos(LoginRequiredMixin, generic.ListView):
    template_name = "shi/list_turnos.html"
    model = Turnos
    context_object_name = "obj"
    login_url = "home:login"

##### CREATE #####
## generic.CreateView
class NewTurnos(LoginRequiredMixin, generic.CreateView):
    template_name = "shi/new_turnos.html"
    model = Turnos
    context_object_name = "obj"
    form_class = TurnosForm
    login_url = "home:login"
    success_url = reverse_lazy("shi:list_turnos")

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)

##### UPDATE #####
## generic.UpdateView
class UpdateTurnos(LoginRequiredMixin, generic.UpdateView):
    template_name = "shi/update_turnos.html"
    model = Turnos
    context_object_name = "obj"
    form_class = TurnosForm
    login_url = "home:login"
    success_url = reverse_lazy("onv:list_turnos")

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)



##### DELETE #####
## generic.DeleteView
class DeleteTurnos(LoginRequiredMixin, generic.DeleteView):
    template_name = "shi/delete_turnos.html"
    model = Turnos
    context_object_name = "obj"
    login_url = "home:login"
    success_url = reverse_lazy("shi:list_Turnos")

class ListContribucion(LoginRequiredMixin, generic.ListView):
    template_name = "shi/list_contribucion.html"
    model = Contribucion
    context_object_name = "obj"
    login_url = "home:login"


##### CREATE #####
## generic.CreateView
class NewContribucion(LoginRequiredMixin, generic.CreateView):
    template_name = "shi/new_contribucion.html"
    model = Contribucion
    context_object_name = "obj"
    form_class = ContribucionForm
    login_url = "home:login"
    success_url = reverse_lazy("shi:list_contribucion")

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)

##### UPDATE #####
## generic.UpdateView
class UpdateContribucion(LoginRequiredMixin, generic.UpdateView):
    template_name = "shi/update_category.html"
    model = Contribucion
    context_object_name = "obj"
    form_class = ContribucionForm
    login_url = "home:login"
    success_url = reverse_lazy("shi:list_contribucion")

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)



##### DELETE #####
## generic.DeleteView
class DeleteContribucion(LoginRequiredMixin, generic.DeleteView):
    template_name = "shi/delete_contribucion.html"
    model = Contribucion
    context_object_name = "obj"
    login_url = "home:login"
    success_url = reverse_lazy("shi:list_contribucion")

cundina/templates/shi/delete_contribucion.html
{% extends "base.html" %}

{% block title %}DeleteContribucion{% endblock title%}


{% block page_content %}
  ¿Realmente quieres eliminar al objeto <h3>{{ obj }}</h3>?
  <form action="" method="post">
    {% csrf_token %}
    <button type="submit" name="button" class="btn btn-circle btn-lg btn-danger">Yes</button>
    <a href="{% url 'shi:list_contribucion' %}" class="btn btn-circle btn-lg btn-warning">No</a>
  </form>

{% endblock page_content %}

cundina/templates/shi/delete_turnos.html
{% extends "base.html" %}

{% block title %}DeleteTurno{% endblock title%}


{% block page_content %}
  ¿Realmente quieres eliminar al objeto <h3>{{ obj }}</h3>?
  <form action="" method="post">
    {% csrf_token %}
    <button type="submit" name="button" class="btn btn-circle btn-lg btn-danger">Yes</button>
    <a href="{% url 'shi:list_turnos' %}" class="btn btn-circle btn-lg btn-warning">No</a>
  </form>

{% endblock page_content %}

cundina/templates/shi/list_contribucion.html
{% extends "base.html" %}

{% block title %}Measure List{% endblock title %}

{% block page_content %}


<!-- Dropdown Card Example -->
<div class="card shadow mb-4">
  <!-- Card Header - Dropdown -->
  <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
    <h6 class="m-0 font-weight-bold text-primary">Contributions</h6>
    <div class="dropdown no-arrow">
      <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
        <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
      </a>
      <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in" aria-labelledby="dropdownMenuLink">
        <div class="dropdown-header">Actions:</div>
        <a class="dropdown-item" href="{% url 'shi:new_contribucion' %}"><i class="far fa-calendar-plus"></i>NewContribution</a>
        <a class="dropdown-item" href=""></a>
        <div class="dropdown-divider"></div>
        <a class="dropdown-item" href="#"></a>
      </div>
    </div>
  </div>
  <!-- Card Body -->
  <div class="card-body">
    {% if not obj %}
      <h3> Not Contributions Yet!! </h3>
    {% else %}
      <table class="table table-striped table-hover">
        <thead>
          <th> Id </th>
          <th> Cundina </th>
          <th> contribuyente </th>
          <th> Aporte </th>
          <th> Update </th>
          <th class="all"> Actions </th>
        </thead>
        <tbody>
          {% for item in obj %}
             <tr>
               <th>{{ item.id }}</th>
               <th>{{ item.cundina }}</th>
               <th>{{ item.contribuyente }}</th>
               <th>{{ item.aporte }}</th>
               <th>{{ item.update|date:"d/m/Y H:i:s" }}</th>
               <th>
                 <a href="{% url 'shi:update_contribucion' item.pk %}" class="btn btn-warning btn-circle" role="button"><i class="far fa-edit"></i></a>
                 <a href="{% url 'shi:delete_contribucion' item.pk %}" class="btn btn-danger btn-circle" role="button"><i class="far fa-trash-alt"></i></a>
               </th>
             </tr>
          {% endfor %}
        </tbody>
      </table>
    {% endif %}
  </div>
</div>



{% endblock page_content %}

{% block js_scripts %}
  <script type="text/javascript">
    // Call the DataTable JQuery plugin//
    $(document).ready(function(){
      $('.table').DataTable();
    });
  </script>>
{% endblock js_scripts %}

cundina/templates/shi/list_turnos.html
{% extends "base.html" %}

{% block title %}Measure List{% endblock title %}

{% block page_content %}


<!-- Dropdown Card Example -->
<div class="card shadow mb-4">
  <!-- Card Header - Dropdown -->
  <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
    <h6 class="m-0 font-weight-bold text-primary">Shifts</h6>
    <div class="dropdown no-arrow">
      <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
        <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
      </a>
      <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in" aria-labelledby="dropdownMenuLink">
        <div class="dropdown-header">Actions:</div>
        <a class="dropdown-item" href="{% url 'shi:new_turnos' %}"><i class="far fa-calendar-plus"></i>NewShift</a>
        <a class="dropdown-item" href=""></a>
        <div class="dropdown-divider"></div>
        <a class="dropdown-item" href="#"></a>
      </div>
    </div>
  </div>
  <!-- Card Body -->
  <div class="card-body">
    {% if not obj %}
      <h3> Not Shifts Yet!! </h3>
    {% else %}
      <table class="table table-striped table-hover">
        <thead>
          <th> Id </th>
          <th> Cundina </th>
          <th> Turno </th>
          <th> Gerente </th>
          <th> Update </th>
          <th class="all"> Actions </th>
        </thead>
        <tbody>
          {% for item in obj %}
             <tr>
               <th>{{ item.id }}</th>
               <th>{{ item.cundina }}</th>
               <th>{{ item.turnos }}</th>
               <th>{{ item.gerente }}</th>
               <th>{{ item.update|date:"d/m/Y H:i:s" }}</th>
               <th>
                 <a href="{% url 'shi:update_turnos' item.pk %}" class="btn btn-warning btn-circle" role="button"><i class="far fa-edit"></i></a>
                 <a href="{% url 'shi:delete_turnos' item.pk %}" class="btn btn-danger btn-circle" role="button"><i class="far fa-trash-alt"></i></a>
               </th>
             </tr>
          {% endfor %}
        </tbody>
      </table>
    {% endif %}
  </div>
</div>



{% endblock page_content %}

{% block js_scripts %}
  <script type="text/javascript">
    // Call the DataTable JQuery plugin//
    $(document).ready(function(){
      $('.table').DataTable();
    });
  </script>>
{% endblock js_scripts %}

cundina/templates/shi/new_contribucion.html
{% extends "base.html" %}

{% block title %} NewContribucion {% endblock title %}


{% block page_content %}
  <form method="post" class="form-inline" action="">
    {% csrf_token %}
    {{ form }}
    <button type="submit" class="btn btn-success btn-circle btn-lg" name="button">Save</button>
    <a href="{% url 'shi:list_contribucion' %} " class="btn btn-circle btn-warning btn-lg">Back</a>
  </form>
{% endblock page_content %}

cundina/templates/shi/new_turnos.html
{% extends "base.html" %}

{% block title %} NewTurnos {% endblock title %}


{% block page_content %}
  <form method="post" class="form-inline" action="">
    {% csrf_token %}
    {{ form }}
    <button type="submit" class="btn btn-success btn-circle btn-lg" name="button">Save</button>
    <a href="{% url 'shi:list_turnos' %} " class="btn btn-circle btn-warning btn-lg">Back</a>
  </form>
{% endblock page_content %}

cundina/templates/shi/update_contribucion.html
{% extends "base.html" %}

{% block title %} UpdateContribucion {% endblock title %}


{% block page_content %}
  <form method="post" class="form-inline" action="">
    {% csrf_token %}
    {{ form }}
    <button type="submit" class="btn btn-success btn-circle btn-lg" name="button">Save</button>
    <a href="{% url 'shi:list_contribucion' %} " class="btn btn-circle btn-warning btn-lg">Back</a>
  </form>
{% endblock page_content %}

cundina/templates/shi/update_turnos.html
{% extends "base.html" %}

{% block title %} UpdateTurnos {% endblock title %}


{% block page_content %}
  <form method="post" class="form-inline" action="">
    {% csrf_token %}
    {{ form }}
    <button type="submit" class="btn btn-success btn-circle btn-lg" name="button">Save</button>
    <a href="{% url 'shi:list_turnos' %} " class="btn btn-circle btn-warning btn-lg">Back</a>
  </form>
{% endblock page_content %}